#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <ggi/graphlib.h>

#define MAXX 320
#define MAXY 400

#define WINSIZE 159
#define WINY    99

unsigned char field[MAXY][MAXX];
unsigned char color[MAXY][MAXX];
unsigned char drawscreen[64000];

struct posdata
 { int x,y,z,range,vvz;
   double alpha,phi;} pdt;

struct pos {int x,y,z;} scanbase[2*WINSIZE];

void display(void)
{ int dx,dy,dz,dxy;
  register int delta,delta1,dd,dov;
  unsigned char *grphptr;
  int xl,yl,zl;
  int sx,sy,sz;
  int xp,mxh,vz;
/*  char hst[40];*/

  for(xp=0;xp<2*WINSIZE;xp++)
  {grphptr=(unsigned char *) drawscreen+(100+WINY)*320+xp;
   if (xp>0&&memcmp((void *)&scanbase[xp],(void *)&scanbase[xp-1],sizeof(scanbase[0]))==0)
      {dz=WINY+WINY+1;
       while(dz--) {*grphptr=*(grphptr-1);grphptr-=320;}
       continue;}
   xl=pdt.x;yl=pdt.y;zl=pdt.z;
   dx=scanbase[xp].x;
   dy=scanbase[xp].y;
   dz=scanbase[xp].z;vz=-WINY-dz;mxh=-WINY;
   delta=delta1=dd=0;
   sx=(dx>0) ? 1 : -1;
   sy=(dy>0) ? 1 : -1;
   sz=(dz>0) ? 1 : -1;
   dx=abs(dx);dy=abs(dy);dz=abs(dz);
   delta=dy-dx;if (abs(delta)>=2) delta>>=1;
   if ((dov=dxy=dx+dy)>dz) delta1--;

   while(dov--)
   {dd++;
    if (delta>=0) {yl+=sy;delta-=dx;}
    else          {xl+=sx;delta+=dy;}
    delta1+=dz;
    while(delta1>=0) {zl+=sz;delta1-=dxy;}
    if (xl<0) if (sx<0) break;else continue;
    if (yl<0) if (sy<0) break;else continue;
    if (xl>=MAXX) if (sx>0) break;else continue;
    if (yl>=MAXY) if (sy>0) break;else continue;
    if (zl>255)   if (sz>0) break;else continue;
    if (field[yl][xl]>zl)
    { dz=((zl=field[yl][xl])-pdt.z)*dxy/dd;
      /*sprintf(hst,"%d",dz);GrTextXY(0,10,hst,63,0);getch();*/
      if (dxy>dz) delta1=-1;else delta1=0;
      if (dz+vz>WINY) dz=WINY-vz;
      while (dz+vz>=mxh)
      { mxh++;*grphptr=color[yl][xl];grphptr-=320; }
      sz=(dz>0) ? 1 : -1;
      if (dz==WINY-vz) break;
      dz=abs(dz);
      }
   }
   while (mxh<=WINY) {mxh++;*grphptr=0;grphptr-=320;}
  }
  ggi_putbox(0,0,320,200,drawscreen);
}

void calc_line(void)
{ int xx;
  double alph2;
  for(xx=0,alph2=pdt.alpha+WINSIZE*pdt.phi;xx<2*WINSIZE;xx++,alph2-=pdt.phi)
  { scanbase[xx].x=sin(alph2)*pdt.range;
    scanbase[xx].y=cos(alph2)*pdt.range;
    scanbase[xx].z=-WINY+pdt.vvz;}
}

int main(int argc,char *argv[])
{ char file[80];
  int xx,yy;
  double xh,yh;
  struct pin { char r,g,b; };
  struct pin palin[256];
  ggi_color pal[256];
  
  ggi_init();
  
  if (ggi_graphmode(640,480,640,480,GT_8BIT)&&
      ggi_graphmode(320,200,320,200,GT_8BIT)
      )
    ggi_panic("Defaultmode not available. Patch me !");
  
  xh=yh=0.0;

  strcpy(file,argv[1]);strcat(file,".col");
  if ((xx=open(file,O_RDONLY))==-1) puts("Color-Data not found");
  else
  { read(xx,&palin,sizeof(palin));
    for(yy=0;yy<256;yy++) 
    { pal[yy].r=palin[yy].r*16;
      pal[yy].g=palin[yy].g*16;
      pal[yy].b=palin[yy].b*16; }
    ggi_setpalvec(0,256,pal);
    read(xx,&color,64000);close(xx);}

  strcpy(file,argv[1]);strcat(file,".hgt");
  if ((xx=open(file,O_RDONLY))==-1) puts("Height-Data not found");
  else
  { read(xx,&palin,sizeof(palin));
    read(xx,&field,64000);close(xx);}

  pdt.x=MAXX/2;pdt.y=0;pdt.z=40;pdt.vvz=0;
  pdt.range=128;pdt.phi=M_PI/2/(5*2*WINSIZE);pdt.alpha=0.0;

  strcpy(file,argv[1]);strcat(file,".pos");
  if ((xx=open(file,O_RDONLY))!=-1)
  { read(xx,&pdt,sizeof(pdt));close(xx); }
  
  for(xx=0;xx<MAXX;xx++)
   for(yy=0;yy<MAXY;yy++)
    field[yy][xx]/=3;

  calc_line();

  do
  { display();
    switch(xx=ggi_getch())
    {case 'f':if (pdt.x!=(int)xh||pdt.y!=(int)yh) {xh=pdt.x;yh=pdt.y;}
	      while(pdt.x==(int)xh && pdt.y==(int)yh)
		{xh+=sin(pdt.alpha);yh+=cos(pdt.alpha);} 
              if ((int)xh<0||(int)xh>MAXX||(int)yh<0||(int)yh>MAXY||
		  field[(int)yh][(int)xh]<pdt.z) {pdt.x=xh;pdt.y=yh;}break;
     case 'r':if (pdt.x!=(int)xh||pdt.y!=(int)yh) {xh=pdt.x;yh=pdt.y;}
	      while(pdt.x==(int)xh && pdt.y==(int)yh)
		{xh-=sin(pdt.alpha);yh-=cos(pdt.alpha);}
              if ((int)xh<0||(int)xh>MAXX||(int)yh<0||(int)yh>MAXY||
		  field[(int)yh][(int)xh]<pdt.z) {pdt.x=xh;pdt.y=yh;}break;
     case ',':pdt.alpha+=0.08;calc_line();break;
     case '.':pdt.alpha-=0.08;calc_line();break;
     case ';':pdt.alpha-=M_PI/8.0;calc_line();break;
     case ':':pdt.alpha+=M_PI/8.0;calc_line();break;
     case 'x':pdt.x++;break;
     case 'X':pdt.x--;break;
     case 'y':pdt.y++;break;
     case 'Y':pdt.y--;break;
     case 'z':pdt.z++;break;
     case 'Z':pdt.z--;break;
     case 's':pdt.x+=10;break;
     case 'S':pdt.x-=10;break;
     case 'a':pdt.y+=10;break;
     case 'A':pdt.y-=10;break;
     case 't':pdt.z+=10;break;
     case 'T':pdt.z-=10;break;
     case '<':pdt.phi*=1.1;calc_line();break;
     case '>':pdt.phi/=1.1;calc_line();break;
     case 'w':pdt.range++;calc_line();break;
     case 'W':pdt.range--;calc_line();break;
     case 'q':pdt.vvz+=10;calc_line();break;
     case 'Q':pdt.vvz-=10;calc_line();break;}
  }while(xx!=27);

  if ((xx=open(file,O_WRONLY))!=-1)
  { write(xx,&pdt,sizeof(pdt));close(xx); }

  ggi_exit();  
  return EXIT_SUCCESS;
}